import java.awt.*;

public class connect4 extends java.applet.Applet {

  SpielFelder Felder[][];
  int x_pos, y_pos;
  int x_Feld, y_Feld;
  Color leerColor, player1Color, player2Color;
  Button restartBtn;
  String currentPlayer;
  final String pl1="player1";
  final String pl2="player2";
 
  public void init() {
    Felder = new SpielFelder[6][6];
    try {
      setBackground(new Color(Integer.parseInt(getParameter("bgcolor"),16)));
      leerColor = new Color(Integer.parseInt(getParameter("leercolor"),16));
      player1Color = new Color(Integer.parseInt(getParameter("player1color"),16));
      player2Color = new Color(Integer.parseInt(getParameter("player2color"),16));
    }
    catch (Exception E) { } 
    restartBtn = new Button("neu beginnen");
    setLayout(null);
    restartBtn.reshape(65, 480, 180, 30);
    restartBtn.setBackground(leerColor);
    add(restartBtn);
    initSpielfeld();
  }


  public Color getLeerColor() {
    return leerColor;
  }


  public Color getPlayer1Color() {
    return player1Color;
  }


  public Color getPlayer2Color() {
    return player2Color;
  }

  public void initSpielfeld() {
    x_pos = 0;
    y_pos = 0;
    currentPlayer = pl1;
    for (x_Feld = 0; x_Feld < 6; x_Feld++) {
      x_pos += 60;
      for (y_Feld = 0; y_Feld < 6; y_Feld++) {
        y_pos += 60;
        if (y_pos == 420) y_pos = 60; 
        Felder[x_Feld][y_Feld] = new SpielFelder(x_pos, y_pos, this);
      }
    }
    repaint();
  }


  public void paint(Graphics g) {
    for(x_Feld = 0; x_Feld < 6; x_Feld++) {
      for (y_Feld = 0; y_Feld < 6; y_Feld++) {
        Felder[x_Feld][y_Feld].erneuern(g);
      }
    } 
    zeigePlayer(g);
  }
 

  public void zeigePlayer(Graphics g) {
    String s;
    if (currentPlayer.equals(pl1)) s = "1";
    else s = "2";
    g.setColor(leerColor);
    g.setFont(new Font("TimesRoman", Font.PLAIN, 20));
    g.drawString("Spieler " + s + " ist am Zug !", 65, 30);
  }
 
  
  public boolean mouseDown(Event evt, int x, int y) {
    if (x >= 60  && x <= 120 && y >= 60 && y <= 420) {
      zugSpalte1();
      return true;
    }
    else if (x >= 121 && x <= 180 && y >= 60 && y <= 420) {
      zugSpalte2();
      return true;
    }
    else if (x >= 181 && x <= 240 && y >= 60 && y <= 420) {
      zugSpalte3();
      return true;
    }
    else if (x >= 241 && x <= 300 && y >= 60 && y <= 420) {
      zugSpalte4();
      return true;
    }
    else if (x >= 301 && x <= 360 && y >= 60 && y <= 420) {
      zugSpalte5();
      return true;
    }
    else if (x >= 361 && x <= 420 && y >= 60 && y <= 420) {
      zugSpalte6();
      return true;
    }
    else return false;
  }


  public void zugSpalte1() {
    x_Feld = 0;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void zugSpalte2() {
    x_Feld = 1;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void zugSpalte3() {
    x_Feld = 2;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void zugSpalte4() {
    x_Feld = 3;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void zugSpalte5() {
    x_Feld = 4;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void zugSpalte6() {
    x_Feld = 5;
    y_Feld = 5;
    while (Felder[x_Feld][y_Feld].mayI_Enter() == false) {
      y_Feld--;
    }
    if (y_Feld >= 0) {
      Felder[x_Feld][y_Feld].setPlayer(currentPlayer);
      Auswertung(x_Feld, y_Feld, currentPlayer);
      if (currentPlayer.equals(pl1)) currentPlayer = pl2;
      else currentPlayer = pl1;
      repaint();
    }
  }


  public void Auswertung(int x, int y, String player) {
    boolean Sieg = false;
    
    if (x-1>=0 && Felder[x-1][y].getStatus().equals(player)) {
      if (x-2>=0 && Felder[x-2][y].getStatus().equals(player)) {
        if (x-3>=0 && Felder[x-3][y].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (x+1<=5 && Felder[x+1][y].getStatus().equals(player)) {
      if (x+2<=5 && Felder[x+2][y].getStatus().equals(player)) {
        if (x+3<=5 && Felder[x+3][y].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (y+1<=5 && Felder[x][y+1].getStatus().equals(player)) {
      if (y+2<=5 && Felder[x][y+2].getStatus().equals(player)) {
        if (y+3<=5 && Felder[x][y+3].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (x-1>=0 && y+1<=5 && Felder[x-1][y+1].getStatus().equals(player)) {
      if (x-2>=0 && y+2<=5 && Felder[x-2][y+2].getStatus().equals(player)) {
        if (x-3>=0 && y+3<=5 && Felder[x-3][y+3].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (x-1>=0 && y-1>=0 && Felder[x-1][y-1].getStatus().equals(player)) { 
      if (x-2>=0 && y-2>=0 && Felder[x-2][y-2].getStatus().equals(player)) {
        if (x-3>=0 && y-3>=0 && Felder[x-3][y-3].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (x+1<=5 && y+1<=5 && Felder[x+1][y+1].getStatus().equals(player)) {
      if (x+2<=5 && y+2<=5 && Felder[x+2][y+2].getStatus().equals(player)) {
        if (x+3<=5 && y+3<=5 && Felder[x+3][y+3].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (x+1<=5 && y-1>=0 && Felder[x+1][y-1].getStatus().equals(player)) {
      if (x+2<=5 && y-2>=0 && Felder[x+2][y-2].getStatus().equals(player)) {
        if (x+3<=5 && y-3>=0 && Felder[x+3][y-3].getStatus().equals(player)) {
          Sieg = true;
        }
      }
    }
    if (Sieg == true) SiegerEhrung(player);
  }

  
  public void SiegerEhrung(String s) {
    SiegFrame SiegFrm = new SiegFrame(s);
    initSpielfeld();
  }

 
  public boolean action(Event evt, Object arg) {
    if (evt.target == restartBtn) {
      initSpielfeld();
      return true;
    }
    else return false;
  }


}



class SpielFelder {

  boolean player1;
  boolean player2;
  boolean leer;
  int x, y;
  connect4 target;

  SpielFelder(int x_pos, int y_pos, connect4 outerparent) {
    this.x = x_pos;
    this.y = y_pos;
    this.leer = true;
    this.player1 = false;
    this.player2 = false;
    target = outerparent;
  }
 
  public void erneuern(Graphics g) {
    if (leer == true) {
      g.setColor(target.getLeerColor());
      g.fillOval(x + 5, y + 5, 55, 55); 
    }
    if (player1 == true) {
      g.setColor(target.getPlayer1Color());
      g.fillOval(x + 5, y + 5, 55, 55); 
    }
    if (player2 == true) {
      g.setColor(target.getPlayer2Color());
      g.fillOval(x + 5, y + 5, 55, 55); 
    }
  }

  
  public void setPlayer(String s) {
    if (s.equals("player1")) {
      player1 = true;
    }
    if (s.equals("player2")) {
      player2 = true;
    }
    leer = false;
  }
  
  public boolean mayI_Enter() {
    if (leer == true) return true;
    else return false;
  }
  
  public String getStatus() {
    if (leer == true) return "leer";
    else if (player1 == true) return "player1";
    else if (player2 == true) return "player2";
    else return "";
  }
}



class SiegFrame extends Frame {
  Button OKBtn;
  
  SiegFrame(String s) {
    super("Sieg fuer "+s+" !");
    Button OKBtn = new Button("Fertig");
    setLayout(new GridLayout(2,1,5,5));
    add(new Label("Gratuliere, "+s+" !    Sie haben gewonnen !", Label.CENTER));  
    Panel Pnl = new Panel();
    Pnl.add(OKBtn);
    add(Pnl);
    this.resize(300,150);
    this.show();
  }


  public boolean handleEvent(Event evt) {
    if (evt.id == evt.WINDOW_DESTROY) {
      this.hide();
      return true;
    }
    if (evt.id == evt.ACTION_EVENT) {
      if (evt.target == OKBtn) this.hide();
      return true;
    }
    else return false;
  } 

}